(*
   SNU 4541.664A
*)

structure Error =
struct
  exception Lex_err of string * int

  val linenum = ref 0
  fun incr_ln () = linenum++
  fun decr_ln () = linenum--
  fun get_ln () = !linenum

  fun handle_exn (Lex_err (s,i)) = 
      prerr_string ">> lex error in line ";
      prerr_int i; prerr_string ": "; prerr_endline s
   |  handle_exn  (Parsing.Parse_error) = 
      prerr_string ">> syntax error in line "; 
      prerr_int !linenum; prerr_newline ()
   |  handle_exn  (Arg.Bad s) = 
      prerr_string (">> file format error: " ^ s);
      prerr_newline ()
   |  handle_exn  v = raise v 
end
